#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

#
# Exif Dump Program V1.3
# by Satoshi Imai
#
wm title . ExifDump

if {$tcl_platform(platform) == "windows"} {
    catch {option add *Font {{lr } 10}}
} else {
    catch {option add *Font {k14}}
}

set SubIFD_offset 0
set ThumbNail_offset 0
set ThumbNail_size 0
set ThumbNail_type 0
set ThumbNail_format 0
set ThumbNail_width 0
set ThumbNail_height 0
set Endian MM
set Exif_file {}

array set TagInfo {
    0x0100 {TlC摜̕ {} pixel}
    0x0101 {TlC摜̍ {} pixel}
    0x0102 {RGBsNZ̕\ւ̃ItZbg {} {}}
    0x0103 {摜̈k` {1 TIFF񈳏k 6 JPEGk} {}}
    0x0106 {摜̌` {1  2 RGB 3 YCbCr} {}}
    0x010e {摜̐ {} {}}
    0x010f {J[J[ {} {}}
    0x0110 {J̋@ {} {}}
    0x0111 {񈳏kTlC摜̃ItZbg {} {}}
    0x0112 {摜̋N_ {1  3 E 6 E 8  9 `} {}}
    0x0115 {sNZ̃f[^ {} {}}
    0x0116 {f[^[̉C {} {}}
    0x0117 {񈳏kTlC摜̃TCY {} {}}
    0x011a {摜̉̕𑜓x {} dpi}
    0x011b {摜̍̉𑜓x {} dpi}
    0x011c {YCbCr̕ {1 Y/Cb/Cr 2 SY/SCb/SCr} {}}
    0x0128 {摜̉𑜓x̒P {1 PʂȂ 2 inch 3 cm} {}}
    0x0131 {J̃t@[EFA̔Ő {} {}}
    0x0132 {摜ύX {} {}}
    0x013e {_̐Fx {} {}}
    0x013f {F̐Fx {} {}}
    0x0201 {JPEGTlC摜̃ItZbg {} {}}
    0x0202 {JPEGTlC摜̃TCY {} {}}
    0x0211 {YCbCrW {} {}}
    0x0212 {Ԉ {} {}}
    0x0213 {Tv|Cg {1  2 _} {}}
    0x0214 {_lƔ_l {} {}}
    0x8298 {摜̒쌠 {} {}}
    0x829a {Io {} sec}
    0x829d {YFl {} {}}
    0x8769 {SubIFDւ̃ItZbg {} {}}
    0x8822 {Io {0 ` 1 }jAIo 2 vOAE 3 iDAE 4 Vb^[DAE 5 ᑬvOAE 6 vOAE 7 |[g[g[h 8 hXP[v[h} {}}
    0x8827 {x(ISO) {} {}}
    0x9000 {Exifo[W {} {}}
    0x9003 {Be {} {}}
    0x9004 {fW^ꂽ {} {}}
	0x9101 {eR|[lg̈Ӗ {394500 RGB 197121 YCbCr} {}}
    0x9102 {JPEGɂ鈳k {} {}}
    0x9201 {Vb^[Xs[h {} sec}
    0x9202 {Yil {} {}}
    0x9203 {BeΏە̖邳 {} EV}
    0x9204 {Io␳l {} EV}
    0x9205 {YJFl {} {}}
    0x9206 {ʑ̂܂ł̋ {} m}
    0x9207 { {1  2 d_ 3 X|bg 4 }`X|bg 5  6 } {}}
    0x9208 { {0 s 1  2 u 3 M 17 WA 18 WB 19 WC} {}}
    0x9209 {tbV {0 Ȃ 1 } {}}
    0x920a {Yœ_ {} mm}
    0x927c {[J[ˑf[^ {} {}}
    0x9286 {[U[Rg {} {}}
    0xa000 {tbVsbNX̃o[W {} {}}
    0xa001 {F {1 sRGB 65535 Uncalibrated} {}}
    0xa002 {C摜̕ {} pixel}
    0xa003 {C摜̍ {} pixel}
    0xa004 {t@C {} {}}
    0xa005 {ExifR98f[^ {} {}}
    0xa20e {CCD̉̉fx {} {}}
    0xa20f {CCD̏c̉fx {} {}}
    0xa210 {CCDfx̒P {1 PʂȂ 2 inch 3 cm} {}}
    0xa217 {C[WZT[̌` {1 ` 2 PJ[ZT 3 2J[ZT 4 3J[ZT 5 FJ[ZT 7 3jAZT 8 FjAZT} {}}
	0xa300 {t@C\[X {3 DSC} {}}
	0xa301 {V[^Cv {1 ڎBeꂽ摜} {}}
	0xa401 {JX^摜 {0 ʏ폈 1 JX^} {}}
	0xa402 {Io[h {0 I[g 1 }jA 2 I[guPbg} {}}
	0xa403 {zCgoX {0 I[g 1 }jA} {}}
	0xa404 {fW^Y[ {} {}}
	0xa405 {Yœ_(35mmtBZ) {} mm}
	0xa406 {Be[h {0 W 1 i 2 |[g[g 3 i} {}}
	0xa407 {QCRg[ {0 Ȃ 1 {Low gain up} 2 {High gain up} 3 {Low gain down} 4 {High gain down}} {}}
	0xa408 {RgXg {0 W 1 \tg 2 n[h} {}}
	0xa409 {ʓx {0 W 1 Low  2 High} {}}
	0xa40a {V[vlX {0 W 1 \tg 2 n[h} {}}
	0xa40c {ʑ͈̂̋ {0 s 1 }N 2 ߌi 3 i} {}}
}

pack [frame .toolbar] -anchor w -fill x
button .open -text J... \
	-highlightthickness 0 -borderwidth 1 -padx 0 -pady 0 -command ExifOpen
button .extract -text TlCo... -state disabled \
	-highlightthickness 0 -borderwidth 1 -padx 0 -pady 0 -command Extract
button .close -text  \
	-highlightthickness 0 -borderwidth 1 -padx 0 -pady 0 -command exit
pack .open .extract -in .toolbar -side left -pady 1
pack .close -in .toolbar -side right

pack [frame .main] -fill both -expand 1
text .text -height 38 -yscroll {.sv set} -xscroll {.sh set} -wrap none
scrollbar .sv -command {.text yview}
scrollbar .sh -orient horizontal -command {.text xview}
grid .text -in .main -row 0 -column 0 -sticky nsew
grid .sv -in .main -row 0 -column 1 -sticky ns
grid .sh -in .main -sticky we
grid columnconfigure .main 0 -weight 1
grid rowconfigure .main 0 -weight 1

proc print {str} {
    .text insert end $str
}

proc clear {} {
    .text delete 1.0 end
    .extract configure -state disabled
}

proc FNum {str} {
    regsub / $str .0/ str
    return [format %.1f [expr pow(sqrt(2), ceil($str))]]
}

proc Speed {str} {
    regsub / $str .0/ str
	if {$str < 0} {
    	return [format %.2f [expr 1.0/pow(2, $str)]]
	} else {
		return 1/[expr int(ceil(pow(2, $str)))]
	}
}

proc ReadData {fd size} {
    global Endian
    set data [read $fd $size]
    if {$size == 2} {
	binary scan $data H2H2 v1 v2
	if {$Endian == "II"} {
	    return 0x$v2$v1
	} else {
	    return 0x$v1$v2
	}
    } elseif {$size == 4} {
	binary scan $data H2H2H2H2 v1 v2 v3 v4
	if {$Endian == "II" } {
	    return 0x$v4$v3$v2$v1
	} else {
	    return 0x$v1$v2$v3$v4
	}
    } else {
	error "Illegal Data Size"
    }
}

proc Data2Info {fd tag fmt data1 data2} {
    global TagInfo Endian
    set save [tell $fd]
    seek $fd [expr $data2+12] start
    switch [expr $fmt] {
	1	-
	6	{if {$Endian == "II"} {set str [expr $data2]} else {set str [expr $data2>>24&0xff]}}
	4	{set str [expr $data2]}
	9	{set str [expr [format %d $data2]]}
	3	-
	8	{if {$Endian == "II"} {set str [expr $data2]} else {set str [expr $data2>>16&0xffff]}}
	7	{if {$Endian == "II"} {set i i} else {set i I}; set bin [binary format $i $data2]; binary scan $bin A* str; set str [encoding convertto ascii $str]}
	2	{set str [ReadString $fd $data1]}
	5	{set str [expr [ReadData $fd 4]]/[expr [ReadData $fd 4]]}
	10	{set str [expr [format %d [ReadData $fd 4]]]/[expr [ReadData $fd 4]]}
	default	{set str {}}
    }
    seek $fd $save start
    if [info exist TagInfo($tag)] {
	print "[lindex $TagInfo($tag) 0] = "
	set next [lindex $TagInfo($tag) 1]
	if {$next != {}} {
	    array set tmp $next 
	    set n [expr $str]
	    if [info exist tmp($n)] {
		print $tmp($n)\n
		return
	    }
	}
    } else {
	print s\n
    }
    if {$tag == 0x829d || $tag == 0x9202 || $tag == 0x9205} {
	set str "$str ([FNum $str])"
    } elseif {$tag == 0x9201} {
	set str "$str ([Speed $str])"
    }
    if [info exist TagInfo($tag)] {
	set next [lindex $TagInfo($tag) 2]
	if {$next != {}} {
	    print "$str $next\n"
	} else {
	    print $str\n
	}
    }
}

proc ReadIFD {fd} {
    global SubIFD_offset ThumbNail_offset ThumbNail_size ThumbNail_type
    global ThumbNail_width ThumbNail_height ThumbNail_format
    set n [ReadData $fd 2]
    for {set i 1} {$i <= $n} {incr i} {
	set tag [ReadData $fd 2]
	set fmt [ReadData $fd 2]
	set data1 [ReadData $fd 4]
	set data2 [ReadData $fd 4]
	print [format "%2d: 0x%04x %2d 0x%08x 0x%08x " $i $tag $fmt $data1 $data2]
	if {$tag == 0x8769} {
	    set SubIFD_offset $data2
	} elseif {$tag == 0x0111 || $tag == 0x0201} {
	    set ThumbNail_offset $data2
	} elseif {$tag == 0x0117 || $tag == 0x0202} {
	    set ThumbNail_size $data2
	} elseif {$tag == 0x0103} {
	    set ThumbNail_type $data2
	} elseif {$tag == 0x0106} {
	    set ThumbNail_format $data2
	} elseif {$tag == 0x100} {
	    set ThumbNail_width $data2
	} elseif {$tag == 0x101} {
	    set ThumbNail_height $data2
	} elseif {$tag == 0x9101} {
		set fmt 9
	} elseif {$tag == 0xa300 || $tag == 0xa301} {
		set fmt 3
	} elseif {$tag == 0x9209} {
		set data2 [expr $data2 & 1]
	}
	Data2Info $fd $tag $fmt $data1 $data2
    }
    return [ReadData $fd 4]
}

proc ReadString {fd size} {
    set data [read $fd $size]
    binary scan $data A* str
    return $str
}

proc WriteBmpHeader {fdw thumb_size thumb_width thumb_height} {
    # marker
    puts -nonewline $fdw BM

    # bmp size
    set size [expr $thumb_size+0x36]
    set bin [binary format i $size]
    puts -nonewline $fdw $bin

    # reserved
    set bin [binary format i 0x0]
    puts -nonewline $fdw $bin

    # start address of datas
    set bin [binary format i 0x36]
    puts -nonewline $fdw $bin

    # size of [0E-35]
    set bin [binary format s 0x28]
    puts -nonewline $fdw $bin

    # dummy
    set bin [binary format s 0x0]
    puts -nonewline $fdw $bin

    # width
    set bin [binary format i $thumb_width]
    puts -nonewline $fdw $bin

    # height
    set bin [binary format i $thumb_height]
    puts -nonewline $fdw $bin

    # color planes
    set bin [binary format s 0x1]
    puts -nonewline $fdw $bin

    # bits/pixel
    set bin [binary format s 24]
    puts -nonewline $fdw $bin

    # compress format
    set bin [binary format s 0x0]
    puts -nonewline $fdw $bin

    # dummy
    set bin [binary format s 0x0]
    puts -nonewline $fdw $bin

    # BMP data size
    set bin [binary format i $thumb_size]
    puts -nonewline $fdw $bin

    # width pixels/meter
    set bin [binary format i 0x0]
    puts -nonewline $fdw $bin

    # height pixels/meter
    set bin [binary format i 0x0]
    puts -nonewline $fdw $bin

    # color tables
    set bin [binary format s 0x0]
    puts -nonewline $fdw $bin

    # dummy
    set bin [binary format s 0x0]
    puts -nonewline $fdw $bin

    # color indexes
    set bin [binary format i 0x0]
    puts -nonewline $fdw $bin
}

proc WriteTiffHeader {fdw thumb_size thumb_width thumb_height} {
    # byte align
    set bin [binary format s 0x4949]
    puts -nonewline $fdw $bin

    # tag mark
    set bin [binary format s 0x002a]
    puts -nonewline $fdw $bin

    # offset to first IFD
    set bin [binary format i 0x08]
    puts -nonewline $fdw $bin

    # number of directory entry
    set bin [binary format s 0x1]
    puts -nonewline $fdw $bin

    # kind of data
    set bin [binary format s 0xfe00]
    puts -nonewline $fdw $bin

}

proc Extract {} {
    global ThumbNail_offset ThumbNail_size ThumbNail_type Exif_file
    global ThumbNail_width ThumbNail_height ThumbNail_format
    if {$ThumbNail_offset != 0 && $ThumbNail_size != 0} {
	if [catch {open $Exif_file r} fdr] {
	    tk_messageBox -title Error -message "$Exif_file ̃I[vɎs܂B" -type ok -icon error
	    return
	}
	fconfigure $fdr -translation binary
	if {$ThumbNail_type == 1} {
	    if {$ThumbNail_format == 2} {
		set type .bmp
		set types {{ "Bmp File" 	{.bmp} }}
	    } else {
		set type .tif
		set types {{ "Tiff File" 	{.tif} }}
	    }
	} else {
	    set type .jpg
	    set types {{ "Jpeg File" 	{.jpg} }}
	}
	seek $fdr [expr $ThumbNail_offset+12] start
	set thumb [read $fdr $ThumbNail_size]
	set file [tk_getSaveFile -filetypes $types -title ۑ -defaultextension $type]
	if {$file == ""} {
	    close $fdr
	    return
	}
	if [catch {open $file w} fdw] {
	    tk_messageBox -title Error -message "$file ̃I[vɎs܂B" -type ok -icon error
	    close $fdr
	}
	fconfigure $fdw -translation binary

	if {$ThumbNail_type == 1 && $ThumbNail_format == 2} {
	    WriteBmpHeader $fdw $ThumbNail_size $ThumbNail_width $ThumbNail_height
	}

	puts -nonewline $fdw $thumb
	close $fdw
	close $fdr
    }
}

proc ExifOpen {} {
    global Exif_file Endian SubIFD_offset ThumbNail_offset ThumbNail_size ThumbNail_type
	set ThumbNail_offset 0
	set ThumbNail_size 0
	set ThumbNail_type 0
    set Endian MM
    set types {
	{ "Exif File" 	{.jpg .jpeg .JPG .JPEG} }
	{ "All File" 	{*} }
    }
    set file [tk_getOpenFile -filetypes $types -title J]
    if { $file == "" } {
	return
    }
    if [catch {open $file r} fdr] {
	tk_messageBox -title Error -message "$file ̃I[vɎs܂B" -type ok -icon error
	return
    }
    set Exif_file $file
    wm title . "ExifDump $file"
    cd [file dirname $file]
    fconfigure $fdr -translation binary

    clear
    # SOI
    set marker [ReadData $fdr 2]
    print "SOI = $marker\n"

    # APP1
    set marker [ReadData $fdr 2]
    print "APP1 = $marker\n"

    if {$marker != 0xffe1} {
	tk_messageBox -title Error -message "̃t@CExifł͂܂B" -type ok -icon error
	close $fdr
	return
    }

    # size
    set size [ReadData $fdr 2]
    print "Size = $size\n"

    # Exif header
    set header [ReadString $fdr 6]
    print "Exif Header = $header\n"

    # Tiff header
    # Byte align
    set Endian [ReadString $fdr 2]
    print "Tiff Byte Align = $Endian\n"

    # TAG Mark
    set marker [ReadData $fdr 2]
    print "Tiff TAG Mark = $marker\n"

    # Offset to first IFD
    set offset [ReadData $fdr 4]
    print "Offset to first IFD = $offset\n"

    set i 0
    while {1} {
	print "IFD$i\n"
	set next [ReadIFD $fdr]
	if {$next == 0} {
	    break
	}
	seek $fdr [expr $next+12] start
	incr i
    }

    if {$SubIFD_offset != 0} {
	seek $fdr [expr $SubIFD_offset+12] start
	print "SubIFD\n"
	ReadIFD $fdr
    }

    if {$ThumbNail_offset != 0 && $ThumbNail_size != 0} {
	.extract configure -state normal
    }

    close $fdr
}
